from lxml import etree
import glob
import datetime

def s(e):
    if e is not None:
        return etree.tostring(e, method="text", encoding='utf8').strip().decode('utf-8')
    return ""

def no_re(s):
    while s.startswith("Re: "):
        s = s[4:]
    return s

messages = []

fns = glob.glob('*.xml')
for fn in fns:
    tree = etree.parse(fn)
    msgs = tree.findall('.//privmsg')
    for msg in msgs:
        messages.append({
            "subject" : s(msg.find('subject')),
            "sender" : s(msg.find('sender')),
            "date" : s(msg.find('date')),
            "message" : s(msg.find('message')),
            "recipient" : s(msg.find('recipient')),
        })

messages.sort(key=lambda x: x['date'])

threads = {}

for msg in messages:
    ident = (msg['sender'], no_re(msg['subject']))
    if msg['recipient']:
        ident = (msg['recipient'], no_re(msg['subject']))
    if ident not in threads:
        threads[ident] = []
    threads[ident].append(msg)

f = open("messages.html", "w")

f.write("""
<html>
<head>
<title>Deskthority - Downloaded Private Messages</title>
</head>
<body>
""")

for t in threads:
    f.write(f"<h1>{t[0]}: {t[1]}</h1>")
    for msg in threads[t]:
        f.write(f"From: {msg['sender']} <br />")
        f.write(f"Date: {msg['date']} <br />")
        if msg['recipient']:
            f.write(f"To: {msg['recipient']} <br />")
        f.write(f"{msg['message']}")
        f.write("<hr />")
f.write("</body>")
f.close()
